\\ Copyright 2014, 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

default(strictargs,1);
read("/tmp/consseg-generated.gp");

size=length(m[1,]);
mat_row_is_zero(m,r) = vecsum(m[r,])==0;
mat_col_is_zero(m,c) = vecsum(m[,c])==0;
\\ for(i=1,size, if(mat_row_is_zero(t,i), print(i)));
\\ for(i=1,size, if(!mat_col_is_zero(t,i), print("col ",i)));

print(matdet(m));
t = mattranspose(m);
v = v~;
{
  my(total = 0);
  for(i=1,20,
     my(n = v[2]+v[3]);
     total = 2*total + n;
     print(n, " ", total);
     v = t*v;
  );
}
