\\ Copyright 2014, 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


gf_terms(g,n) = \
  my(x = variable(g), \
     zeros = min(n,valuation(g,x)), \
     v = Vec(g + O(x^n))); \
  if(zeros>=0, concat(vector(zeros,i,0), v), \
               v[-zeros+1 .. #v]);

\\ g(x)
\\ [16, -40, 32, -24, 16, 0, -8, 9, -9, 5]

\\rec_vector = [16, -40, 32, -24, 16, 0, -8,  9, -9, 5]
rec_vector = [2,0,1]
rec_vector = [1,1]
rec_pol = Pol(rec_vector);
print("rec_pol ",rec_pol);

\\all_values = [1, 0, 0, 0, 2, 4, 10, 20, 46, 100, 218, 460, 998, 2140] \\ , 4562
\\all_values = [2, 3, 5, 9, 15, 25, 43, 73, 123, 209, 355, 601, 1019, 1729];
all_values = vector(10,i,fibonacci(i+2))
all_pol = Polrev(all_values)
print("all by rec");
rec_pol*all_pol

low_values = all_values[1..#rec_vector];
print("low_values  ",low_values);
low_pol = Polrev(low_values);
print("low_pol  ",low_pol);
low_product_mod = (rec_pol*low_pol) % x^(#rec_vector-1)
print("low_product_mod ",low_product_mod)
print("mul")
x*(rec_pol*all_pol - low_product_mod) + low_pol
\\ x*(rec_pol*g(x) - low_product_mod) + low_pol == g(x)
\\ x*rec_pol*g(x) - x*low_product_mod + low_pol == g(x)
\\ (x*rec_pol-1)*g(x) == x*low_product_mod - low_pol 
\\ g(x) == (x*low_product_mod - low_pol )/(x*rec_pol-1)
g(x) = (x*low_product_mod - low_pol )/(x*rec_pol-1);
g(x)
gf_terms(g(x),20)
gf_terms(g(x),#all_values) == all_values

quit
x*rec_pol*g(x)

dot_product(u,v) = sum(i=1,max(#u,#v), u[i]*v[i]);
dot_product(low_values, rec_vector) == 218
x*rec_pol*low_pol
x*rec_pol*low_pol - (x*rec_pol*low_pol) % x^#rec_vector
\\ g(x)*rec_pol - (low_pol*rec_pol) % x^#rec_vector + low_pol = g(x)
g(x) = 1/(1-rec_pol) *( - (low_pol*rec_pol) % x^#rec_vector + low_pol)


